【LeetCode:3098. 求出所有子序列的能量和 + 记忆化缓存】

|-----------|
| 🚀 算法题 🚀 |

🌲 算法刷题专栏 | 面试必备算法 | 面试高频算法 🍀
🌲 越难的东西,越要努力坚持,因为它具有很高的价值,算法就是这样✨
🌲 作者简介:硕风和炜,CSDN-Java领域优质创作者🏆,保研|国家奖学金|高中学习JAVA|大学完善JAVA开发技术栈|面试刷题|面经八股文|经验分享|好用的网站工具分享💎💎💎
🌲 恭喜你发现一枚宝藏博主,赶快收入囊中吧🌻
🌲 人生如棋,我愿为卒,行动虽慢,可谁曾见我后退一步?🎯🎯

|-----------|
| 🚀 算法题 🚀 |


🍔 目录

    • [🚩 题目链接](#🚩 题目链接)
    • [⛲ 题目描述](#⛲ 题目描述)
    • [🌟 求解思路&实现代码&运行结果](#🌟 求解思路&实现代码&运行结果)
      • [⚡ 记忆化缓存](#⚡ 记忆化缓存)
        • [🥦 求解思路](#🥦 求解思路)
        • [🥦 实现代码](#🥦 实现代码)
        • [🥦 运行结果](#🥦 运行结果)
    • [💬 共勉](#💬 共勉)

🚩 题目链接

⛲ 题目描述

给你一个长度为 n 的整数数组 nums 和一个 正 整数 k 。

一个 子序列 的 能量 定义为子序列中 任意 两个元素的差值绝对值的 最小值 。

请你返回 nums 中长度 等于 k 的 所有 子序列的 能量和 。

由于答案可能会很大,将答案对 109 + 7 取余 后返回。

示例 1:

输入:nums = 1,2,3,4, k = 3

输出:4

解释:

nums 中总共有 4 个长度为 3 的子序列:1,2,3 ,1,3,4 ,1,2,4 和 2,3,4 。能量和为 |2 - 3| + |3 - 4| + |2 - 1| + |3 - 4| = 4 。

示例 2:

输入:nums = 2,2, k = 2

输出:0

解释:

nums 中唯一一个长度为 2 的子序列是 2,2 。能量和为 |2 - 2| = 0 。

示例 3:

输入:nums = 4,3,-1, k = 2

输出:10

解释:

nums 总共有 3 个长度为 2 的子序列:4,3 ,4,-1 和 3,-1 。能量和为 |4 - 3| + |4 - (-1)| + |3 - (-1)| = 10 。

提示:

2 <= n == nums.length <= 50

-108 <= numsi <= 108

2 <= k <= n

🌟 求解思路&实现代码&运行结果


⚡ 记忆化缓存

🥦 求解思路
  1. 理解题目的意思,其实就是让我们找到所有长度为k子序列(递归),然后求解每种子序列中任意俩个数绝对差最小的结果返回,累加所有绝对差并返回。
  2. 注意:子序列是有序的,但是收集最小差的过程是任意的,所有数组的顺序就对最终的结果没有影响,我们可以先对数组进行排序。
  3. 第一种思路:设计一个递归,从i位置开始,搜集k个数,收集的每个数使用list收集,最后判断最小值返回。但是时间超限,缓存也超时,递归设计的有问题,继续修改递归。
  4. 第二种思路,依然设计一个递归,从i位置开始,收集k个数,pre表示之前选择的数,min表示该递归路径下的最小差值,递归超时,缓存通过。
  5. 有了基本的思路,接下来我们就来通过代码来实现一下的解法。
🥦 实现代码
java 复制代码
class Solution {

    private final int mod = (int) 1e9 + 7;
    private HashMap<String, Long> map = new HashMap<>();

    public int sumOfPowers(int[] nums, int k) {
        int n = nums.length;
        Arrays.sort(nums);
        return (int) process(0, nums, k, -1, Integer.MAX_VALUE);
    }

    public long process(int index, int[] nums, int k, int pre, int min) {
        if (index >= nums.length) {
            return k == 0 ? min : 0;
        }
        if (k > nums.length - index) {
            return 0;
        }
        String key = index + "#" + k + "#" + pre + "#" + min;
        if (map.containsKey(key)) {
            return map.get(key);
        }
        long p1 = process(index + 1, nums, k, pre, min) % mod;
        long p2 = process(index + 1, nums, k - 1, index, pre == -1 ? min : Math.min(nums[index] - nums[pre], min))
                % mod;
        map.put(key, (p1 + p2) % mod);
        return (p1 + p2) % mod;
    }
}
🥦 运行结果

💬 共勉

|----------------------------------|
| 最后,我想和大家分享一句一直激励我的座右铭,希望可以与大家共勉! |

相关推荐
文丑颜不良啊37 分钟前
LeetCode1461~1480题目解析
java·leetcode
2301_780789668 小时前
跨平台适配!SDK 游戏盾兼容全终端游戏场景
java·网络·ddos
学长毕设9 小时前
基于springboot的食品仓库管理系统
java·spring boot·后端
ZhengEnCi9 小时前
Agent 架构怎么选:从单 Agent 到多 Agent 编排的选型决策指南
算法·架构
步行cgn10 小时前
FormHttpMessageConverter 详解:Spring MVC 中表单数据的读写转换器
java·spring·mvc
龙亘川10 小时前
构建城市公共安全数字底座:亘川智城智慧安防系统全维度解读
java·大数据·开发语言·人工智能·信息可视化
金銀銅鐵10 小时前
[Java] 用 CLI 展示 EnumMap 增删键值对时的内部变化
java·源码·ai编程
秋天的怀念_David10 小时前
第二十二夜 · 数字迷雾
java·程序人生·算法
Raas10010 小时前
AI网关部署方案?从部署到上线全流程
java·开发语言·人工智能·gateway·ai网关·企业级ai网关·企业级ai产品
Pniubi10 小时前
力扣283移动零(双指针法)
算法·leetcode·职场和发展